
#declare P1 = function{ pattern{ leopard turbulence 0.3 scale 0.05 } }
#declare P2 = function{ pattern{ crackle turbulence 0.3 scale 0.7 } }
#declare P = function{ P1(x*0.4,0,z*0.4)*0.4 +P2(x,0,z)*0.4 }

#declare C_roche01 = srgb < 20, 10, 28 > / 255;
#declare C_roche02 = srgb < 28, 20, 40 > / 255;
                                 
#declare T_mtgClair = texture{ pigment{ wrinkles color_map{
                                                       [0.0 C_roche01 ]
                                                       [0.2 srgb 1]
                                                       [0.3 srgb 1]
                                                       [0.4 C_roche02 ]
                                                       [0.5 srgb 1]
                                                       [9.0 srgb 1]
                                                       [1.0 C_roche01 ]
                                                      }
                                    scale <0.05,1,0.05>
                                   }
                           }
                          
#declare T_mtgNeige = texture{ pigment{ wrinkles color_map{
                                                       [0.0 srgb 1]
                                                       [0.1 C_roche01]
                                                       [0.2 srgb 1]
                                                       [0.3 C_roche02]
                                                       [0.4 srgb 1]
                                                       [0.5 srgb 1]
                                                       [0.7 C_roche01]
                                                       [0.8 srgb 1]
                                                       [0.9 C_roche02]
                                                       [1.0 srgb 1]
                                                      }
                                    scale < 0.05, 2, 0.05 >
                                   }
                          }
                          
#declare T_roche = texture{ pigment{ agate color_map{
                                                 [0.2 color srgb <0.55, 0.50, 0.50>]
                                                 [0.6 color srgb <0.75, 0.50, 0.60>]
                                                 [1.0 color srgb <0.70, 0.60, 0.60>]
                                                }
                                   scale 0.2 warp{turbulence 0.5}
                                }
                         finish{specular 0.2 diffuse 0.4 ambient <0.8, 0.9, 1.4>*0.06}
                         normal{granite 0.6 scale 0.1}
                        }
                                                                                                                                               
#declare BackgroundMountains =
height_field{
	function 500,500{ P(x,0,y) }
	texture{
		pigment{ slope{y} color_map
							{
								[0.5 color srgb 0.32 ]//< 0.36, 0.25, 0.20 > * < 0.8, 0.9, 1 > * 1.15 ]
								[0.6 color srgb 0.4 ]//< 0.35, 0.16, 0.14 > * < 0.8, 0.9, 1 > * 1.15 ]
								[0.7 color srgb 1.2]
								[0.8 color srgb 1.4]
								[1.0 color srgb 1.4]
							}  
		}
	}                  
	translate <-0.5,0,-0.5>
} 

#declare Barriere=
union {
		cylinder{ <0.5,0,0.5> <0.5,4,0.5> ,0.5 texture { T_Wood16} }
		cylinder{ <9.5,0,0.5> <9.5,4,0.5> ,0.5 texture { T_Wood16} }
		cylinder{<0,4.5,0.5> <10,4.5,0.5>,0.5 texture { T_Wood16} }
		sphere{ <0.5,5,0.5>, 0.2 pigment {Gray} }
		sphere {<9.5,5,0.5>,0.2 pigment {Gray} }
} 

#declare Estrade=
union {
	union {
       prism {
			linear_sweep linear_spline
             0,1,7,
             <-20,0> <40,0> <70,20> <70,80> <30,40> <-20,40> <-20,0>
             }
      prism {    //Prisme p8
             linear_sweep linear_spline
             0,2,7,
             <-20,0> <40,0> <70,20> <70,77.5> <31,37.5> <-20,37.5> <-20,0>
             } 
      prism { //Prisme p7
             linear_sweep linear_spline
             0,3,7,
             <-20,0> <40,0> <70,20> <70,75> <32,35> <-20,35> <-20,0>
             }                                        
      prism {   //Prisme p6
             linear_sweep linear_spline
             0,4,7,
             <-20,0> <40,0> <70,20> <70,72.5> <33,32.5> <-20,32.5> <-20,0>
             }                                                      
     prism {//Prisme p5
           linear_sweep linear_spline
           0,5,7
             <-20,0> <40,0> <70,20> <70,70> <34,30> <-20,30> <-20,0>
             }
     prism {//Prisme p4
            linear_sweep linear_spline
            0,6,7,
            <-20,0> <40,0> <70,20> <70,67.5> <35,27.5> <-20,27.5> <-20,0>
            }
     prism {//Prisme p3
            linear_sweep linear_spline
            0,7,7
            <-20,0> <40,0> <70,20> <70,65> <36,25> <-20,25> <-20,0>
    }
	prism{
		linear_sweep linear_spline
		0,8,7
		<-20,0> <40,0> <70,20> <70,62.5> <37,22.5> <-20,22.5> <-20,0>    
	}
	prism{
		linear_sweep linear_spline
		0,9,7,
		<-20,-40> <40,-40> <70,20> <70,60> <38,20> <-20,20> <-20,-40>
	}             
}       
	object {Barriere translate <-10,9,-38>}
	object {Barriere translate <0,9,-38>}
	object {Barriere translate <10,9,-38>}
	object {Barriere translate <20,9,-38>}
	object {Barriere translate <30,9,-38>}
    
    union {
		object {Barriere translate <0 ,9,0>}
		object {Barriere translate <10 ,9,0>}
		object {Barriere translate <20 ,9,0>}
		object {Barriere translate <30 ,9,0>}
		object {Barriere translate <40 ,9,0>}
		object {Barriere translate <50 ,9,0>}
		rotate -64*y translate <40,0,-38>
	}
}
     
#declare SnowAndGranite =   
	texture{ T_Stone8 }
	texture{ pigment{ wrinkles color_map{ 
									[0.0 srgb 1]
									[0.5 srgb 1]
									[0.5 srgbf <1,1,1,1> ]
									[1.0 srgbf <1,1,1,1> ]
								}
				}
	}